/* The staff of CHO - designed in MORAY, actually. It was placed in the
   priest's hand by exporting the hand from Rhino to MORAY UDO, putting
   the staff in it graphically, then deleting the hand UDO and exporting
   just the staff, which was later union'ed with the triangle meshes of
   the priest. Pity you get so little detail from final camera angle, as
   I spent over and hour just designing the fancy heels for the staff.
*/

#declare RareOak =
   texture  // RareOak
   {
      pigment
      {
         wood
         color_map
         {
            [ 0.0     rgbft <0.742316, 0.467453, 0.278484, 0.0, 0.0> ]
            [ 0.1     rgbft <0.690765, 0.427616, 0.246702, 0.0, 0.0> ]
            [ 0.9     rgbft <0.6736, 0.485292, 0.3472, 0.0, 0.0> ]
            [ 1.0     rgbft <0.701378, 0.529096, 0.402756, 0.0, 0.0> ]
         }
         turbulence 0.06
         sine_wave
         scale  <0.02, 0.02, 0.1>
      }
   }

#declare New_Soft_Silver =
   texture  // New_Soft_Silver
   {
      pigment
      {
         color rgb <0.94, 0.93, 0.83>
      }
      finish
      {
         ambient 0.2
         diffuse 0.4
         brilliance 3.0
         specular 0.85
         roughness 0.01
         metallic 1.0
         reflection 0.06
      }
   }

#declare Sapphire_Beads =
   texture  // Sapphire_Beads
   {
      pigment
      {
         color rgbf <0.239567, 0.364567, 1.0, 0.5>
      }
      finish
      {
         ambient 0.3
         diffuse 0.65
         phong_size 0.0
         specular 0.5
         roughness 0.01
         reflection 0.1
         refraction on  ior 1.33
      }
   }

#declare Glass_Sphere =
   texture  // Glass_Sphere
   {
      pigment
      {
         color rgbf <0.9479, 0.989567, 1.0, 0.75>
      }
      finish
      {
         ambient 0.3
         diffuse 0.65
         phong_size 0.0
         specular 0.5
         roughness 0.01
         reflection 0.1
         refraction on  ior 1.33
      }
}

#declare Bead = object {
  sphere { // Bead
    <0,0,0>,1
    texture {
      Sapphire_Beads
    }
    scale <0.1, 0.1, 0.8>
    translate  <1.0, 0.0, -1.0>
  }
}
#declare Bead12 = object {
  sphere { // Bead12
    <0,0,0>,1
    texture {
      Sapphire_Beads
    }
    scale <0.1, 0.1, 0.8>
    translate  <1.0, 0.0, -1.0>
  }
}

#declare Cresent_Moon = difference {
  cylinder { // Cylndr001
    <0,0,1>, <0,0,0>, 1
    rotate -90.0*x
  }
  cylinder { // Cylndr002
    <0,0,1>, <0,0,0>, 1
    scale <1.0, 1.0, 1.5>
    rotate -90.0*x
    translate  <0.645911, -0.2, -0.010135>
  }
  texture {
    New_Soft_Silver
  }
  scale <2.666678, 1.0, 2.702692>
  rotate <-0.0, -11.523273, -30.969999>
  translate  <0.586522, -0.46682, 6.927803>
}
#declare Staffcap = union {
  superellipsoid { // Upperheel
    <1.0, 0.1>
    texture {
      New_Soft_Silver
    }
    scale <1.0, 1.0, 2.0>
    translate  -1.0*z
  }
  sphere { // SilverOrb
    <0,0,0>,1
    texture {
      New_Soft_Silver
    }
    scale <1.75, 1.75, 1.7>
    translate  <-0.020913, 0.0, 2.0>
  }
  object { Bead }
  object { // Bead1->Bead
    Bead
    translate  <-0.133975, -0.5, 0.0>
  }
  object { // Bead2->Bead
    Bead
    translate  <-0.5, -0.866025, 0.0>
  }
  object { // Bead3->Bead
    Bead
    translate  <-1.0, -1.0, 0.0>
  }
  object { // Bead4->Bead
    Bead
    translate  <-1.5, -0.866025, 0.0>
  }
  object { // Bead5->Bead
    Bead
    translate  <-1.866025, -0.5, 0.0>
  }
  object { // Bead6->Bead
    Bead
    translate  <-2.0, 0.0, 0.0>
  }
  object { // Bead7->Bead
    Bead
    translate  <-1.866025, 0.5, 0.0>
  }
  object { // Bead8->Bead
    Bead
    translate  <-1.5, 0.866025, 0.0>
  }
  object { // Bead9->Bead
    Bead
    translate  <-1.0, 1.0, 0.0>
  }
  object { // Bead10->Bead
    Bead
    translate  <-0.5, 0.866025, 0.0>
  }
  object { // Bead11->Bead
    Bead
    translate  <-0.133975, 0.5, 0.0>
  }
  object { Cresent_Moon }
  cone { // connector
    <0,0,0>, 0.15, <0,0,1>, 0.1
    texture {
      New_Soft_Silver
    }
    scale <2.666678, 2.702703, 0.810807>
    rotate <-0.0, -2.0, 0.0>
    translate  <0.014991, -0.000459, 3.620858>
  }
  scale <0.375, 0.37, 0.37>
  rotate -2.0*y
  translate  <18.549825, -0.04, 35.06294>
}
#declare Staffcap2 = union {
  superellipsoid { // Upperheel1
    <1.0, 0.1>
    texture {
      New_Soft_Silver
    }
    scale <1.0, 1.0, 2.0>
    translate  -1.0*z
  }
  sphere { // SilverOrb1
    <0,0,0>,1
    texture {
      New_Soft_Silver
    }
    scale <1.6, 1.6, 1.7>
    translate  <-0.020913, 0.0, 2.0>
  }
  object { Bead12 }
  object { // Bead13->Bead12
    Bead12
    translate  <-0.133975, -0.5, 0.0>
  }
  object { // Bead14->Bead12
    Bead12
    translate  <-0.5, -0.866025, 0.0>
  }
  object { // Bead15->Bead12
    Bead12
    translate  <-1.0, -1.0, 0.0>
  }
  object { // Bead16->Bead12
    Bead12
    translate  <-1.5, -0.866025, 0.0>
  }
  object { // Bead17->Bead12
    Bead12
    translate  <-1.866025, -0.5, 0.0>
  }
  object { // Bead18->Bead12
    Bead12
    translate  <-2.0, 0.0, 0.0>
  }
  object { // Bead19->Bead12
    Bead12
    translate  <-1.866025, 0.5, 0.0>
  }
  object { // Bead20->Bead12
    Bead12
    translate  <-1.5, 0.866025, 0.0>
  }
  object { // Bead21->Bead12
    Bead12
    translate  <-1.0, 1.0, 0.0>
  }
  object { // Bead22->Bead12
    Bead12
    translate  <-0.5, 0.866025, 0.0>
  }
  object { // Bead23->Bead12
    Bead12
    translate  <-0.133975, 0.5, 0.0>
  }
  scale <-0.375, -0.37, -0.37>
  rotate <0.0, 2.0, -180.0>
  translate  <19.703234, -0.04, 1.281682>
}

#declare Staff =
union { // Staff
  object { Staffcap }
  cylinder { // Staffbody
    <0,0,1>, <0,0,0>, 1
    texture {
      RareOak
    }
    scale <0.35, 0.35, 35.0>
    rotate -2.0*y
    translate  <19.766791, -0.04, 0.062941>
  }
  object { Staffcap2 }

/*RHC -> LHC conversion*/ rotate -90*x  scale <1,1,-1>
}




